/* A simple plot application

 Copyright (c) 1998 The Regents of the University of California.
 All rights reserved.
 Permission is hereby granted, without written agreement and without
 license or royalty fees, to use, copy, modify, and distribute this
 software and its documentation for any purpose, provided that the above
 copyright notice and the following two paragraphs appear in all copies
 of this software.

 IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
 FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
 ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
 THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
 SUCH DAMAGE.

 THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
 PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
 CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
 ENHANCEMENTS, OR MODIFICATIONS.

                                        PT_COPYRIGHT_VERSION_2
                                        COPYRIGHTENDKEY
*/

import ptolemy.plot.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.StringTokenizer;

//////////////////////////////////////////////////////////////////////////
//// SimplePlotApplication
/**
SimplePlotApplication is a simple example that uses the Plot class.

To compile and run this application, do the following:
<pre>
cd ptolemy/plot
cp demo/SimplePlotApplication.java .
setenv CLASSPATH ../..
javac SimplePlotApplication.java
java ptolemy.plot.SimplePlotApplication demo/data.plt
</pre>

@author Christopher Hylands
@version $Id: PlotApplication.java,v 1.3 1998/11/17 21:09:37 cxh Exp $
*/
public class SimplePlotApplication extends Frame {

    public SimplePlotApplication(String args[]) {
        _myPlotter = new Plot();
        //_makeButtons();

        pack();
        add("Center",_myPlotter);
        try {
            _myPlotter.clear(true);
            _myPlotter.read(new FileInputStream(args[1]));
        } catch (FileNotFoundException ex) {
            Message msg = new Message("File not found: " + ex);
        } catch (IOException ex) {
            Message msg = new Message("Error reading input: " + ex);
        }
        show();
        _myPlotter.init();
    }

    public static void main(String args[]) {
        Pxgraph pxgraph = new Pxgraph(args);
    }

    private Plot _myPlotter;
}
