/**********
Copyright 1990 Regents of the University of California.  All rights reserved.
Author: 1985 Thomas L. Quarles
**********/
/*
 */

#include "spice.h"
#include <stdio.h>
#include "cktdefs.h"
#include "opampdefs.h"
#include "sperror.h"
#include "suffix.h"


/*ARGSUSED*/
int
OPAMPload(inModel,ckt)
    GENmodel *inModel;
    CKTcircuit *ckt;
        /* actually load the current voltage value into the 
         * sparse matrix previously provided 
         */
{
    register OPAMPmodel *model = (OPAMPmodel *)inModel;
    register OPAMPinstance *here;

/********************/
double inter1;
double p_inter1_SRp;
double p_inter1_SRm;
double inter2;
double p_inter2_inter1;
double I1m;
double p_I1m_Ccomp;
double p_I1m_inter2;
double inter3;
double p_inter3_SRp;
double p_inter3_SRm;
double inter4;
double x01;
double p_x01_inter4;
double inter5;
double p_inter5_Ioutp;
double p_inter5_Ioutm;
double I2m;
double p_I2m_inter5;
double inter6;
double p_inter6_Ioutp;
double p_inter6_Ioutm;
double inter7;
double x02;
double p_x02_inter7;
double inter8;
double p_inter8_Av0;
double p_inter8_Vt;
double inter9;
double p_inter9_inter8;
double p_inter9_Vt;
double inter10;
double p_inter10_I1m;
double p_inter10_I2m;
double inter11;
double p_inter11_inter10;
double p_inter11_Rout;
double R1;
double p_R1_inter9;
double p_R1_inter11;
double inter12;
double p_inter12_Vt;
double inter13;
double p_inter13_Voutm;
double p_inter13_Voutp;
double inter14;
double p_inter14_Vt;
double inter15;
double p_inter15_inter13;
double p_inter15_inter14;
double inter16;
double p_inter16_inter15;
double inter17;
double p_inter17_inter12;
double p_inter17_inter16;
double I3m;
double p_I3m_inter17;
double p_I3m_Rout;
double inter18;
double p_inter18_Voutp;
double p_inter18_Voutm;
double DVout_2;
double p_DVout_2_inter18;
double i_inplus;
double p_i_inplus_v_inplus;
double d_i_inplus_v_inplus;
double i_inminus;
double p_i_inminus_v_inminus;
double d_i_inminus_v_inminus;
double inter19;
double p_inter19_v_inplus;
double p_inter19_v_inminus;
double inter20;
double p_inter20_v_inplus;
double p_inter20_v_inminus;
double inter21;
double p_inter21_inter20;
double inter22;
double p_inter22_inter21;
double p_inter22_CMRR;
double inter23;
double p_inter23_inter19;
double p_inter23_inter22;
double inter24;
double p_inter24_inter23;
double p_inter24_Vos;
double xa;
double p_xa_inter24;
double p_xa_Vt;
double d_inter19_v_inminus;
double d_inter20_v_inminus;
double d_inter21_v_inminus;
double d_inter22_v_inminus;
double d_inter23_v_inminus;
double d_inter24_v_inminus;
double d_xa_v_inminus;
double d_inter19_v_inplus;
double d_inter20_v_inplus;
double d_inter21_v_inplus;
double d_inter22_v_inplus;
double d_inter23_v_inplus;
double d_inter24_v_inplus;
double d_xa_v_inplus;
double inter25;
double p_inter25_xa;
double inter26;
double p_inter26_xa;
double p_inter26_x01;
double inter27;
double p_inter27_inter26;
double inter28;
double p_inter28_inter25;
double p_inter28_inter27;
double Ia;
double p_Ia_I1m;
double p_Ia_inter28;
double d_inter25_v_inminus;
double d_inter26_v_inminus;
double d_inter27_v_inminus;
double d_inter28_v_inminus;
double d_Ia_v_inminus;
double d_inter25_v_inplus;
double d_inter26_v_inplus;
double d_inter27_v_inplus;
double d_inter28_v_inplus;
double d_Ia_v_inplus;
double inter29;
double p_inter29_v_inode;
double p_inter29_R1;
double i_inode;
double p_i_inode_Ia;
double p_i_inode_inter29;
double d_inter29_v_inode;
double d_i_inode_v_inode;
double d_i_inode_v_inminus;
double d_i_inode_v_inplus;
double xb;
double p_xb_v_inode;
double p_xb_Vt;
double d_xb_v_inode;
double inter30;
double p_inter30_xb;
double inter31;
double p_inter31_I2m;
double p_inter31_inter30;
double inter32;
double p_inter32_xb;
double p_inter32_x01;
double inter33;
double p_inter33_inter32;
double Ib;
double p_Ib_inter31;
double p_Ib_inter33;
double d_inter30_v_inode;
double d_inter31_v_inode;
double d_inter32_v_inode;
double d_inter33_v_inode;
double d_Ib_v_inode;
double inter34;
double p_inter34_v_outplus;
double p_inter34_DVout_2;
double xc;
double p_xc_inter34;
double p_xc_Vt;
double d_inter34_v_outplus;
double d_xc_v_outplus;
double inter35;
double p_inter35_xc;
double inter36;
double p_inter36_I3m;
double p_inter36_inter35;
double Ic;
double p_Ic_Ib;
double p_Ic_inter36;
double d_inter35_v_outplus;
double d_inter36_v_outplus;
double d_Ic_v_outplus;
double d_Ic_v_inode;
double inter37;
double p_inter37_v_outplus;
double p_inter37_Rout;
double i_outplus;
double p_i_outplus_Ic;
double p_i_outplus_inter37;
double d_inter37_v_outplus;
double d_i_outplus_v_outplus;
double d_i_outplus_v_inode;
/********************/

double Ccomp, SRp, SRm, Ioutp, Ioutm, Av0, Vt, Rout, Voutm, Voutp, CMRR, Vos;

double v_inplus, v_inminus, v_outplus, v_inode;


    /*  loop through all the voltage source models */
    for( ; model != NULL; model = model->OPAMPnextModel ) {

        /* loop through all the instances of the model */
        for (here = model->OPAMPinstances; here != NULL ;
                here=here->OPAMPnextInstance) {

Ccomp = here->OPAMPCcomp;
SRp = here->OPAMPSRp;
SRm = here->OPAMPSRm;
Ioutp = here->OPAMPIoutp;
Ioutm = here->OPAMPIoutm;
Av0 = here->OPAMPAv0;
Vt = here->OPAMPVt;
Rout = here->OPAMPRout;
Voutm = here->OPAMPVoutm;
Voutp = here->OPAMPVoutp;
CMRR = here->OPAMPCMRR;
Vos = here->OPAMPVos;

v_inplus = *(ckt->CKTrhsOld+here->OPAMPinplus);
v_inminus = *(ckt->CKTrhsOld+here->OPAMPinminus);
v_outplus = *(ckt->CKTrhsOld+here->OPAMPoutplus);
v_inode = *(ckt->CKTrhsOld+here->OPAMPinode);

/********************/
/* statement : I1m = Ccomp * pow((SRp * SRm), 0.5) */
inter1 = SRp * SRm;
p_inter1_SRp = SRm;
p_inter1_SRm = SRp;
inter2 = pow( inter1, 5.000000e-01 );
p_inter2_inter1 = 5.000000e-01 * pow( inter1, (5.000000e-01 - 1) );
I1m = Ccomp * inter2;
p_I1m_Ccomp = inter2;
p_I1m_inter2 = Ccomp;

/* statement : x01 = 0.5 * log(SRp / SRm) */
inter3 = SRp / SRm;
p_inter3_SRp = ( 1 / SRm );
p_inter3_SRm = ( -SRp / ( pow( SRm, 2)));
inter4 = log( inter3 );
x01 = 5.000000e-01 * inter4;
p_x01_inter4 = 5.000000e-01;

/* statement : I2m = pow((Ioutp * Ioutm), 0.5) */
inter5 = Ioutp * Ioutm;
p_inter5_Ioutp = Ioutm;
p_inter5_Ioutm = Ioutp;
I2m = pow( inter5, 5.000000e-01 );
p_I2m_inter5 = 5.000000e-01 * pow( inter5, (5.000000e-01 - 1) );

/* statement : x02 = 0.5 * log(Ioutp / Ioutm) */
inter6 = Ioutp / Ioutm;
p_inter6_Ioutp = ( 1 / Ioutm );
p_inter6_Ioutm = ( -Ioutp / ( pow( Ioutm, 2)));
inter7 = log( inter6 );
x02 = 5.000000e-01 * inter7;
p_x02_inter7 = 5.000000e-01;

/* statement : R1 = Av0 * Vt * Vt / (I1m * I2m * Rout) */
inter8 = Av0 * Vt;
p_inter8_Av0 = Vt;
p_inter8_Vt = Av0;
inter9 = inter8 * Vt;
p_inter9_inter8 = Vt;
p_inter9_Vt = inter8;
inter10 = I1m * I2m;
p_inter10_I1m = I2m;
p_inter10_I2m = I1m;
inter11 = inter10 * Rout;
p_inter11_inter10 = Rout;
p_inter11_Rout = inter10;
R1 = inter9 / inter11;
p_R1_inter9 = ( 1 / inter11 );
p_R1_inter11 = ( -inter9 / ( pow( inter11, 2)));

/* statement : I3m = 1000.0 *Vt * exp((Voutm - Voutp)/(2 * Vt)) / Rout */
inter12 = 1.000000e+03 * Vt;
p_inter12_Vt = 1.000000e+03;
inter13 = Voutm - Voutp;
p_inter13_Voutm = 1;
p_inter13_Voutp = -1;
inter14 = 2.000000e+00 * Vt;
p_inter14_Vt = 2.000000e+00;
inter15 = inter13 / inter14;
p_inter15_inter13 = ( 1 / inter14 );
p_inter15_inter14 = ( -inter13 / ( pow( inter14, 2)));
inter16 = exp( inter15 );
p_inter16_inter15 = exp( inter15 );
inter17 = inter12 * inter16;
p_inter17_inter12 = inter16;
p_inter17_inter16 = inter12;
I3m = inter17 / Rout;
p_I3m_inter17 = ( 1 / Rout );
p_I3m_Rout = ( -inter17 / ( pow( Rout, 2)));

/* statement : DVout_2 = (Voutp + Voutm)/2.0 */
inter18 = Voutp + Voutm;
p_inter18_Voutp = 1;
p_inter18_Voutm = +1;
DVout_2 = inter18 / 2.000000e+00;
p_DVout_2_inter18 = ( 1 / 2.000000e+00 );

/* statement : i_inplus = v_inplus * 0.0 */
i_inplus = v_inplus * 0.000000e+00;
p_i_inplus_v_inplus = 0.000000e+00;
d_i_inplus_v_inplus = 0 + p_i_inplus_v_inplus;

/* statement : i_inminus = v_inminus * 0.0 */
i_inminus = v_inminus * 0.000000e+00;
p_i_inminus_v_inminus = 0.000000e+00;
d_i_inminus_v_inminus = 0 + p_i_inminus_v_inminus;

/* statement : xa = (v_inplus - v_inminus + 0.5 * (v_inplus + v_inminus) / CMRR - Vos) / Vt */
inter19 = v_inplus - v_inminus;
p_inter19_v_inplus = 1;
p_inter19_v_inminus = -1;
inter20 = v_inplus + v_inminus;
p_inter20_v_inplus = 1;
p_inter20_v_inminus = +1;
inter21 = 5.000000e-01 * inter20;
p_inter21_inter20 = 5.000000e-01;
inter22 = inter21 / CMRR;
p_inter22_inter21 = ( 1 / CMRR );
p_inter22_CMRR = ( -inter21 / ( pow( CMRR, 2)));
inter23 = inter19 + inter22;
p_inter23_inter19 = 1;
p_inter23_inter22 = +1;
inter24 = inter23 - Vos;
p_inter24_inter23 = 1;
p_inter24_Vos = -1;
xa = inter24 / Vt;
p_xa_inter24 = ( 1 / Vt );
p_xa_Vt = ( -inter24 / ( pow( Vt, 2)));
d_inter19_v_inminus = 0 + p_inter19_v_inminus;
d_inter20_v_inminus = 0 + p_inter20_v_inminus;
d_inter21_v_inminus = 0 + p_inter21_inter20 * d_inter20_v_inminus;
d_inter22_v_inminus = 0 + p_inter22_inter21 * d_inter21_v_inminus;
d_inter23_v_inminus = 0 + p_inter23_inter22 * d_inter22_v_inminus + p_inter23_inter19 * d_inter19_v_inminus;
d_inter24_v_inminus = 0 + p_inter24_inter23 * d_inter23_v_inminus;
d_xa_v_inminus = 0 + p_xa_inter24 * d_inter24_v_inminus;
d_inter19_v_inplus = 0 + p_inter19_v_inplus;
d_inter20_v_inplus = 0 + p_inter20_v_inplus;
d_inter21_v_inplus = 0 + p_inter21_inter20 * d_inter20_v_inplus;
d_inter22_v_inplus = 0 + p_inter22_inter21 * d_inter21_v_inplus;
d_inter23_v_inplus = 0 + p_inter23_inter22 * d_inter22_v_inplus + p_inter23_inter19 * d_inter19_v_inplus;
d_inter24_v_inplus = 0 + p_inter24_inter23 * d_inter23_v_inplus;
d_xa_v_inplus = 0 + p_xa_inter24 * d_inter24_v_inplus;

/* statement : Ia = I1m + sinh(xa) / cosh(xa - x01) */
inter25 = sinh( xa );
p_inter25_xa = cosh( xa );
inter26 = xa - x01;
p_inter26_xa = 1;
p_inter26_x01 = -1;
inter27 = cosh( inter26 );
p_inter27_inter26 = - sinh( inter26 );
inter28 = inter25 / inter27;
p_inter28_inter25 = ( 1 / inter27 );
p_inter28_inter27 = ( -inter25 / ( pow( inter27, 2)));
Ia = I1m + inter28;
p_Ia_I1m = 1;
p_Ia_inter28 = +1;
d_inter25_v_inminus = 0 + p_inter25_xa * d_xa_v_inminus;
d_inter26_v_inminus = 0 + p_inter26_xa * d_xa_v_inminus;
d_inter27_v_inminus = 0 + p_inter27_inter26 * d_inter26_v_inminus;
d_inter28_v_inminus = 0 + p_inter28_inter27 * d_inter27_v_inminus + p_inter28_inter25 * d_inter25_v_inminus;
d_Ia_v_inminus = 0 + p_Ia_inter28 * d_inter28_v_inminus;
d_inter25_v_inplus = 0 + p_inter25_xa * d_xa_v_inplus;
d_inter26_v_inplus = 0 + p_inter26_xa * d_xa_v_inplus;
d_inter27_v_inplus = 0 + p_inter27_inter26 * d_inter26_v_inplus;
d_inter28_v_inplus = 0 + p_inter28_inter27 * d_inter27_v_inplus + p_inter28_inter25 * d_inter25_v_inplus;
d_Ia_v_inplus = 0 + p_Ia_inter28 * d_inter28_v_inplus;

/* statement : i_inode = Ia + v_inode / R1 */
inter29 = v_inode / R1;
p_inter29_v_inode = ( 1 / R1 );
p_inter29_R1 = ( -v_inode / ( pow( R1, 2)));
i_inode = Ia + inter29;
p_i_inode_Ia = 1;
p_i_inode_inter29 = +1;
d_inter29_v_inode = 0 + p_inter29_v_inode;
d_i_inode_v_inode = 0 + p_i_inode_inter29 * d_inter29_v_inode;
d_i_inode_v_inminus = 0 + p_i_inode_Ia * d_Ia_v_inminus;
d_i_inode_v_inplus = 0 + p_i_inode_Ia * d_Ia_v_inplus;

/* statement : xb = v_inode / Vt */
xb = v_inode / Vt;
p_xb_v_inode = ( 1 / Vt );
p_xb_Vt = ( -v_inode / ( pow( Vt, 2)));
d_xb_v_inode = 0 + p_xb_v_inode;

/* statement : Ib = I2m *sinh(xb) / cosh(xb - x01) */
inter30 = sinh( xb );
p_inter30_xb = cosh( xb );
inter31 = I2m * inter30;
p_inter31_I2m = inter30;
p_inter31_inter30 = I2m;
inter32 = xb - x01;
p_inter32_xb = 1;
p_inter32_x01 = -1;
inter33 = cosh( inter32 );
p_inter33_inter32 = - sinh( inter32 );
Ib = inter31 / inter33;
p_Ib_inter31 = ( 1 / inter33 );
p_Ib_inter33 = ( -inter31 / ( pow( inter33, 2)));
d_inter30_v_inode = 0 + p_inter30_xb * d_xb_v_inode;
d_inter31_v_inode = 0 + p_inter31_inter30 * d_inter30_v_inode;
d_inter32_v_inode = 0 + p_inter32_xb * d_xb_v_inode;
d_inter33_v_inode = 0 + p_inter33_inter32 * d_inter32_v_inode;
d_Ib_v_inode = 0 + p_Ib_inter33 * d_inter33_v_inode + p_Ib_inter31 * d_inter31_v_inode;

/* statement : xc = (v_outplus - DVout_2) / Vt */
inter34 = v_outplus - DVout_2;
p_inter34_v_outplus = 1;
p_inter34_DVout_2 = -1;
xc = inter34 / Vt;
p_xc_inter34 = ( 1 / Vt );
p_xc_Vt = ( -inter34 / ( pow( Vt, 2)));
d_inter34_v_outplus = 0 + p_inter34_v_outplus;
d_xc_v_outplus = 0 + p_xc_inter34 * d_inter34_v_outplus;

/* statement : Ic = Ib + I3m * sinh(xc) */
inter35 = sinh( xc );
p_inter35_xc = cosh( xc );
inter36 = I3m * inter35;
p_inter36_I3m = inter35;
p_inter36_inter35 = I3m;
Ic = Ib + inter36;
p_Ic_Ib = 1;
p_Ic_inter36 = +1;
d_inter35_v_outplus = 0 + p_inter35_xc * d_xc_v_outplus;
d_inter36_v_outplus = 0 + p_inter36_inter35 * d_inter35_v_outplus;
d_Ic_v_outplus = 0 + p_Ic_inter36 * d_inter36_v_outplus;
d_Ic_v_inode = 0 + p_Ic_Ib * d_Ib_v_inode;

/* statement : i_outplus = Ic + v_outplus / Rout */
inter37 = v_outplus / Rout;
p_inter37_v_outplus = ( 1 / Rout );
p_inter37_Rout = ( -v_outplus / ( pow( Rout, 2)));
i_outplus = Ic + inter37;
p_i_outplus_Ic = 1;
p_i_outplus_inter37 = +1;
d_inter37_v_outplus = 0 + p_inter37_v_outplus;
d_i_outplus_v_outplus = 0 + p_i_outplus_inter37 * d_inter37_v_outplus + p_i_outplus_Ic * d_Ic_v_outplus;
d_i_outplus_v_inode = 0 + p_i_outplus_Ic * d_Ic_v_inode;

/********************/
            
            *(here->OPAMPinode_inode) += 1;
            *(here->OPAMPinplus_inplus) += 1;
            *(here->OPAMPinode_inplus) += d_i_inode_v_inplus;
            *(here->OPAMPinminus_inminus) -= 1.0 ;
            *(here->OPAMPinode_inminus) += d_i_inode_v_inminus;
            *(here->OPAMPoutplus_outplus) += 1.0 ;
            *(here->OPAMPoutplus_inode) += d_i_outplus_v_inode ;
        }
    }
    return(OK);
}
